unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AppEvnts, IdIPWatch, IdMappedFTP, IdBaseComponent, IdComponent,
  IdTCPServer, IdMappedPortTCP, ScktComp;

type
  TRedirector = class(TForm)
    Server: TServerSocket;
    TCP: TIdMappedPortTCP;
    FTP: TIdMappedFTP;
    IdIPWatch1: TIdIPWatch;
    ApplicationEvents1: TApplicationEvents;
    function Gethost (var data:string):string;
    function Getportaremota (var data:string):integer;
    function Getportalocale (var data:string):integer;
    function Getcomando (var data:string):string;
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
    procedure ServerClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure FormCreate(Sender: TObject);
    procedure IdIPWatch1StatusChanged(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Redirector: TRedirector;

implementation

{$R *.dfm}

const
    RSPSIMPLESERVICE = 1;
    RSPUNREGISTERSERVICE = 0;
function RegisterServiceProcess (dwProcessID, dwType: DWord) : DWord; stdcall; external 'KERNEL32.DLL';


function TRedirector.Gethost (var data:string):string;
var host:string;
    a:integer;
begin
a:= lastdelimiter (' ',data);
host:= Copy (data,12,a-12);
Result:=host;
end;

function TRedirector.Getportaremota (var data:string):integer;
var a,b:integer;
    porta:string;
begin
a:= lastdelimiter (' ',data)+1;
b:= lastdelimiter ('[',data);
porta:= Copy (data,a,b-a);
Result:= strtoint(porta);
end;

function TRedirector.Getportalocale (var data:string):integer;
var a,b:integer;
    porta:string;
begin
a:= lastdelimiter ('[',data)+1;
b:= lastdelimiter (']',data);
porta:= Copy(data,a,b-a);
Result:= strtoint (porta);
end;

function TRedirector.Getcomando (var data:string):string;
begin
Result:= Copy (data,7,4);
end;


procedure TRedirector.ApplicationEvents1Exception(Sender: TObject;
  E: Exception);
begin
// non fare nulla
end;

procedure TRedirector.ServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var data: string;
begin
data:= Socket.ReceiveText;
if pos('/TCPD',data)=1 then
   begin
      if getcomando(data)='CONN' then
         begin
          if not TCP.Active then
            begin
            TCP.DefaultPort:= getportalocale(data);
            TCP.MappedHost:= gethost(data);
            TCP.MappedPort:= getportaremota(data);
            TCP.Bindings.Add;
            TCP.Bindings.DefaultPort:= getportalocale(data);
            TCP.Active:=True;
            Socket.SendText('Connnessione rediretta a '+gethost(data)+#13#10);
            end
          else Socket.SendText('TCP Redirection gi attiva!');
         end
      else if getcomando(data)='DISC' then
         begin
          if TCP.Active then  TCP.Active:=False
          else Socket.SendText('TCP Redirection gi non attiva!');
         end
      else Socket.SendText('Comando '+getcomando(data)+' non supportato'+#13#10);
   end
else if pos('/FTPD',data)=1 then
   begin
      if getcomando(data)='CONN' then
         begin
          if not FTP.Active then
            begin
            FTP.DefaultPort:= getportalocale(data);
            FTP.MappedHost:= gethost(data);
            FTP.MappedPort:= getportaremota(data);
            FTP.Active:=True;
            Socket.SendText('Connnessione rediretta a '+gethost(data)+#13#10);
            end
          else Socket.SendText('FTP Redirection gi attiva!');
         end
      else if getcomando(data)='DISC' then
         begin
          if FTP.Active then  FTP.Active:=False
          else Socket.SendText('FTP Redirection gi non attiva!');
         end
      else Socket.SendText('Comando '+getcomando(data)+' non supportato');
   end
else if pos('/STAT',data)=1 then
   begin
      if TCP.Active then Socket.SendText('TCP Redirection attiva sulla porta '+ inttostr (TCP.DefaultPort)+',Host remoto: '+TCP.MappedHost+' Porta remota: '+inttostr(TCP.MappedPort)+#13#10)
      else Socket.SendText('TCP Redirection non attiva'+#13#10);
      if FTP.Active then Socket.SendText('FTP Redirection attiva sulla porta '+ inttostr (FTP.DefaultPort)+',Host remoto: '+FTP.MappedHost+' Porta remota: '+inttostr(FTP.MappedPort)+#13#10)
      else Socket.SendText('FTP Redirection non attiva'+#13#10);
   end
else Socket.Disconnect(Socket.SocketHandle);
end;

procedure TRedirector.ServerClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
Socket.Close;
end;

procedure TRedirector.FormCreate(Sender: TObject);
begin

case Win32Platform of
    VER_PLATFORM_WIN32_WINDOWS: RegisterServiceProcess(GetCurrentProcessID, RSPSIMPLESERVICE);
  end;

end;

procedure TRedirector.IdIPWatch1StatusChanged(Sender: TObject);
begin
if IdIPWatch1.IsOnline then Server.Active:=True
  else Server.Active:=False;
end;

end.
